# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00_cons.ipynb.

# %% auto 0
__all__ = ['ASPEC', 'DSPEC', 'MSPEC', 'SKIND', 'DKIND', 'MKIND', 'ATTRSPECS', 'Spec']

# %% ../nbs/00_cons.ipynb 6
from enum import StrEnum, auto

# %% ../nbs/00_cons.ipynb 8
from typing import Tuple

# %% ../nbs/00_cons.ipynb 10
from nlit import (SPEC, SPECS, INPLACE, __COPYING__, __PASSSELF__, __READONLY__, __ATTRSPECS__,)

# %% ../nbs/00_cons.ipynb 12
#| export


# %% ../nbs/00_cons.ipynb 14
ASPEC: str = 'aspec'
DSPEC: str = 'dspec'
MSPEC: str = 'mspec'

SKIND: set = {'static',  'attr',  ASPEC, 's',  'a'}
DKIND: set = {'dynamic', 'dattr', DSPEC, 'dyn', 'd', }

MKIND = {'mutable', 'mattr', MSPEC, 'mut', 'm', }

ATTRSPECS: set = {ASPEC, DSPEC }

__DKIND__     = '__dkind__'
__SKIND__     = '__skind__'

# %% ../nbs/00_cons.ipynb 16
class Spec(StrEnum):
    '''
    Enumeration class that contains attribute specification keys.

    Attributes
    ----------
    aspec : str
        Key for attribute specification.
        
    dspec : str
        Key for dynamic attribute specification.
    '''    
    aspec = auto()
    dspec = auto()

    @classmethod
    def specs(cls) -> Tuple[str]:
        '''Returns a tuple of all the values.'''
        return tuple(list(map(lambda e: e.value, cls)))

Spec.specs()
